////////////////////////////////////////////////////////////////////
// Entry for Conitec's Winter A6 Demo Contest
// Bopete's Entity Path Demo
// copyright (c) 2004
// a collaborative offering by the Black Love Interactive team
// project director: Gay Crawford aka "Bopete"
// Dolphin Waltz by Louie McCoy
// last edited:  2004 Dec 30

// written with 3D GameStudio 6.31 beta
// free dolphin model courtesy of: www.3dcafe.com

////////////////////////////////////////////////////////////////////

var video_mode = 7; // 800x600 pixels
var video_depth = 32; // 32 bit mode

////////////////////////////////////////////////////////////////////
// define variables

define _COUNTER, skill1;  // used for opening chest lid

entity* Dolphin;
entity* Lid;
entity* Chest;

string dolphin_wmb = <Bopetes_path_demo.wmb>;
string node_string[6];
string node_temp;

font courier_fnt = <courier_new_10_18.pcx>,10,18;

string dolphin1 = <"dolphin_sound1.wav">;
string dolphin2 = <"dolphin_sound2.wav">;
string dolphin3 = <"dolphin_sound3.wav">;

sound water = <"waterflow.wav">;
string dolphin_waltz = <"Dolphin_Waltz.MID">;

var node_pos[3]; // temp storage for node position in AI
var prev_node_pos[3]; // previous node position to check if at the last node
var swim_distance[3];
var tempy[3];
var node = 1; // start at first node	
var node_flag = 0;  // used to make sure there is enough distance from last node
var walker_pos[3];
var force = 1;
var sound_number;
var my_angle[3];
var new_angle[3];
var angle[3];
var dolphin_vector[3];	
var bubble_vector[3];
var which_path = 1;
var sound_handle;

bmap A6logo_small_pcx = <A6logo_small.pcx>;
bmap cursor_bmp = <arrow.bmp>;
bmap demo_title = <demo_title.pcx>;
bmap bubble = <bubble.pcx>;

bmap shell_panel_pcx = <shell_panel.pcx>;
bmap shell_path_off = <shell_path_off.pcx>;
bmap shell_path_ovr = <shell_path_ovr.pcx>;
bmap shell_path_on = <shell_path_on.pcx>;
bmap shell_help_off = <shell_help_off.pcx>;
bmap shell_help_ovr = <shell_help_ovr.pcx>;
bmap shell_help_on = <shell_help_on.pcx>;
bmap shell_end_off = <shell_end_off.pcx>;
bmap shell_end_ovr = <shell_end_ovr.pcx>;
bmap shell_end_on = <shell_end_on.pcx>;


//=============================================================
// define panels

panel demo_title_panel {
	bmap = demo_title;
	pos_x = 280;
  pos_y = 4;
	layer = 99;
	alpha = 80;
	flags overlay,visible,transparent;
}

panel a6_panel {
	bmap = A6logo_small_pcx;
	pos_x = 10;
  pos_y = 0;
	layer = 99;
	alpha = 80;
	flags overlay,visible,transparent;
}

panel shell_panel {
	bmap = shell_panel_pcx;
	pos_x = 724;
  pos_y = 360;
 	alpha = 80; 
	layer = 99;
	digits = 50,0,2,courier_fnt,1,which_path;
	digits = 50,18,2,courier_fnt,1,node;	
	button = 6,40,shell_path_on,shell_path_off,shell_path_ovr,switch_paths,null,null;
	button = 6,107,shell_help_on,shell_help_off,shell_help_ovr,help_text_toggle,null,null;
	button = 6,174,shell_end_on,shell_end_off,shell_end_ovr,end_game,null,null;		
	flags overlay,refresh,visible,transparent;
}

//=============================================================
// define texts

text help_text {
  STRINGS 10;
	pos_x = 400;
	pos_y = 360;
	font courier_fnt;
	layer = 99;  
  string "The dolphin follows one of two paths,";
  string "which can be selected with the Path button.";  
  string "Path nodes are indicated by numbered bubbles.\n"; 
  string "Programs can be written to trigger events";
  string "when an entity travels to a specific path node.\n";  
  string "In this case, when the dolphin approaches";
  string "node 18 on path 1, or node 14 on path 2,";
  string "the treasure chest lid will open or close.";  
  flags = center_x;
}

////////////////////////////////////////////////////////////////////

function main() {
	level_load (dolphin_wmb);
	wait(3);
	
	// initialize some basic settings
	init_game();
	
	// assign bitmap to mouse cursor
	mouse_map = cursor_bmp;
	
	// make mouse visible
	mouse_mode = 1;
	
	// update the cursor as the mouse is moved
	while (1) { 
		mouse_pos.x = pointer.x; 
		mouse_pos.y = pointer.y; 
		wait (1); 
	} 
}

function init_game() {
	camera.fog_start = 220; // distance from camera that fog starts
	camera.fog_end = 4800; // distance from camera that fog is the thickest
	fog_color = 2; // which fog is used
	camera.fog = 30; // density of fog
	
	a6_panel.pos_y = screen_size.y - 100;
	str_cpy(node_string, "node: ");
	media_loop(dolphin_waltz,null,50);
}

function dolphin_turn(&whole_vector) {

	force = 1;
	
	whole_vector[0] = ang(whole_vector[0] - my.pan);
	whole_vector[1] = ang(whole_vector[1] - my.tilt);

	// adjust pan
	if (whole_vector[0] > 10)
	{
		temp = force * 5;
	}
	else
	{
		if(whole_vector[0] < -10)
		{
			temp = -force * 5;
		}	else	{
			temp = force * whole_vector[0] * 0.5;
		}
	}
	my.pan += temp * min(1,time);	
	
	// adjust tilt rate
	if (whole_vector[1] > 10)
	{
		temp = force * 5;
	}
	else
	{
		if(whole_vector[1] < -10)
		{	
			temp = -force * 5;
		}	else {
			temp = force * whole_vector[1] * 0.5;
		}
	}	
	my.tilt += temp * min(1,time);
	bubble_vector.pan = Dolphin.pan;
	bubble_vector.tilt = Dolphin.tilt;
}

function camera_turn(&camera_target) {
	result = vec_to_angle(temp, camera_target);
	camera.pan = temp;
}

action define_bubble_cube {
	my.invisible = on;
	seabubbles();
	while (1) {
		my.passable = on;
		my.x = Dolphin.x;
		my.y = Dolphin.y;
		my.z = Dolphin.z + 10;
		my.pan = Dolphin.pan;
		my.tilt = Dolphin.tilt;
	wait(1);
	}
}


//////////////////////////////////////////////////////////
// actions 
// move along a path loop
action swim_path {

	Dolphin = my;
	
	path_set( Dolphin,"path_001" );

	// find first waypoint
	path_getnode(my,node,node_pos.x,null);
	my.frame = 0;

	while (1)	{
		// find direction
		result = vec_diff(tempy,node_pos.x,my.x);
		
		// near target? Find next waypoint of the path
		if ( abs(tempy.x) < 5 && abs(tempy.y) < 5 && node_flag == 0 ) {  // trips to next node only once
			node = path_nextnode(my,node,1);
			path_getnode(my,node,node_pos.x,NULL);
			node_flag = 1;
			
			// put events here that are triggered at certain path nodes
			if ( ( node == 18 && which_path == 1 ) || ( node == 14 && which_path == 2 ) ) {
				chest_lid_event();	
			}
		}
		
		vec_set(temp, node_pos.x);  // copy position of next node into temp
		vec_sub(temp, my.x); // copy diff between entity position and next node position into temp
		//temp.z = 0;		
		result = vec_to_angle(my_angle, temp);
		
		// call function to change direction
		dolphin_turn(my_angle);
		
		swim_distance.x = 10 * time;
		my.skill55 += 10 * time; // swim speed
		
		move_mode = IGNORE_YOU + IGNORE_PASSABLE + IGNORE_PUSH + ACTIVATE_TRIGGER + GLIDE;
		ent_move(swim_distance, nullvector);
		ent_animate(me,"TailSwim",my.skill55,anm_cycle);
		if ( abs(tempy.x) < 5 && abs(tempy.y) < 5 && node_flag == 1) {  node_flag = 0; } // far enough away from last node to start looking again
		
		// pass location to camera
		dolphin_vector.x = Dolphin.x;
		dolphin_vector.y = Dolphin.y;		
		camera_turn (dolphin_vector);
		
		// play random dolphin sound
		sound_number = int(random(5000)) + 1;
		if ( sound_number < 4 ) {
			dolphin_sound(sound_number);
		}
		
		wait(1);
	}
}

// play random dolphin sounds
function dolphin_sound (which_sound) {
	if (which_sound == 1 ) { media_play(dolphin1,null,50);	}
	if (which_sound == 2 ) { media_play(dolphin2,null,50);	}
	if (which_sound == 3 ) { media_play(dolphin3,null,50);	}
}

// toggle between paths
function switch_paths() {
	snd_play(water,80,0);	
	if ( which_path == 1 ) {
		path_set( Dolphin,"path_002" );
		which_path = 2;
	} else {
		path_set( Dolphin,"path_001" );
		which_path = 1;
	}
	
	// convert to nearby node on other path going opposite direction
	node = 10 - node;
	if ( node <= 0 ) { node += 18; }
}

function chest_lid_event() {
	if (Lid._COUNTER <= 0) { // if lid was closed, open it
		while (Lid._COUNTER < 90) {
			Lid.ROLL -= 3*TIME; // rotate up
			Lid._COUNTER += 3*TIME;
			wait(1);			
		}
		Lid.ROLL += Lid._COUNTER-90; // correct the overshoot
		Lid._COUNTER = 90;
		chest_bubbles();
	}
	else // otherwise close it
	{ 
		while (Lid._COUNTER > 0) {
			Lid.ROLL += 3*TIME; // rotate down
			Lid._COUNTER -= 3*TIME;
			wait(1);
		}
		Lid.ROLL += Lid._COUNTER; // correct the overshoot
		Lid._COUNTER = 0;
	}
}

// toggle help text on and off
function help_text_toggle() {
	snd_play(water,80,0);		
	if help_text.visible == off {
		help_text.visible = on;
	}	 else {
		help_text.visible = off;	
	}
}

function seabubbles_spec_fun() {
  my.skill_b += 0.04;
  my.skill_a = 5  - my.skill_b;
  if(my.skill_a < 0) { my.lifespan = 0; }
  my.alpha -= 5 *time;
}

function sea_bubbles_function() {
    if(my.skill_a < 0) { my.skill_a = 0; my.skill_b = 0; }
    my.bmap = bubble;
    my.vel_x = random(10) - ( 10 / 2 );
    my.vel_y = random(10) - ( 10 / 2 );
    my.vel_z = random(4);
    my.size = 10.0;
    my.move = 1;
    my.alpha = 50;
    my.transparent = 1;
    my.gravity = 0;
    my.streak = 0;
    my.bright = 1;
    my.function = seabubbles_spec_fun;
    my.flare =1;
}

function seabubbles() {
  while(1) {
     effect(sea_bubbles_function,10 * time,my.x,nullvector);
     wait(1 );
  }
}

// define treasure chest lid
action define_chest_lid {
	Lid = my;
	my.event = chest_lid_event;
	my.enable_click = on;
	my._COUNTER = 0; // degree counter, independent of initial angle
}

// define treasure chest
action define_chest {
	Chest = my;
}

function chest_bubbles_function() {
    if(my.skill_a < 0) { my.skill_a = 0; my.skill_b = 0; }
    my.bmap = bubble;
    my.vel_x = random(6) - ( 6 / 2 );
    my.vel_y = random(6) - ( 6 / 2 );
    my.vel_z = random(16) + 8;
    my.size = 24.0;
    my.move = 1;
    my.alpha = 90;
    my.transparent = 1;
    my.gravity = 0;
    my.streak = 0;
    my.bright = 1;
    my.function = seabubbles_spec_fun;
    my.flare =1;		
}

function chest_bubbles() {
	effect(chest_bubbles_function,100 * time,Chest.x,nullvector);
}

function end_game() {
	snd_play(water,80,0);
	sleep(2);  // allow time for sound to play
	exit;
}
